#ifndef __DNS_H
#define __DNS_H

typedef struct _DnsQuery DnsQuery;

typedef void (*DnsLookupFunc)(const void *data, IPADDR *ip);
typedef void (*DnsReverseFunc)(const void *data, const char *host);

DnsQuery *dns_lookup_ip(const char *host, DnsLookupFunc func, const void *data);
DnsQuery *dns_lookup_name(IPADDR *ip, DnsReverseFunc func, const void *data);

void dns_lookup_cancel(DnsQuery *query);

int dns_lookups_init(void);
void dns_lookups_deinit(void);

#endif
