#ifndef __IAUTH_INTERNAL_H
#define __IAUTH_INTERNAL_H

#include "network.h"

struct _IAuthListener {
	struct _IAuthListener *next;

        int refcount;
	int handle;
	IO io;

	int port;
	IPADDR ip;
};

struct _Ircd {
	Pool pool;

	TBuffer *inbuf;
	IO io;

        char *name, *version, *flags, *sid, *info;
};

extern Ircd *ircd;

#ifdef IAUTH_DEBUG
#  define DEBUG(x) debug_log x
#else
#  define DEBUG(x)
#endif

void debug_log(Client *client, const char *format, ...);

void iauth_quit(void);
void iauth_set_ircd_info(Ircd *ircd, const char *server_name,
			 const char *version, const char *flags,
			 const char *sid, const char *info);

/* Create an empty listener. This can be used if you want to fake it for
   outgoing connections. */
IAuthListener *iauth_create_listener(void);

void iauth_listener_ref(IAuthListener *listener);
void iauth_listener_unref(IAuthListener *listener);

/* Add new listener to specified IP/port. IP may be NULL if you
   want to bind it to all interfaces. */
void iauth_add_listener(int port, IPADDR *ip);
/* Find matching IP/port listeners and remove them. IP can be NULL to match
   any, port can be <=0 to match any. */
void iauth_remove_listener(int port, IPADDR *ip);

#endif
