#include "common.h"
#include "iauth-internal.h"

#define PROXY_SCAN_COUNT 6 /* hardcoded, sorry :) */

#define PROXY_STATUS_UNCHECKED	0
#define PROXY_STATUS_CHECKING	1
#define PROXY_STATUS_CHECKED	2

typedef struct _ProxyModuleData ProxyModuleData;
typedef struct _ProxyCheck ProxyCheck;

/* Returns -1 = need more data, 0 = no open proxy, 1 = open proxy */
typedef int (*ProxyScanFunc)(ProxyCheck *);

struct _ProxyCheck {
	ProxyModuleData *module;

	int num; /* 0..PROXY_SCAN_COUNT-1 */
	int status; /* PROXY_STATUS_xxx */
        int internal_status; /* check specific */

	int handle;
	IO io;

	TBuffer *inbuf, *outbuf;
};

struct _ProxyModuleData {
        Client *client;

        IPADDR my_ip;
        int my_port;

        ProxyCheck checks[PROXY_SCAN_COUNT];
        Timeout to;

	unsigned int closed:1;
};

extern Pool proxy_pool;

/* Start scanning for proxies */
void proxy_scan_start(ProxyModuleData *data);

/* Called when all proxies are scanned, or checking is aborted */
void proxy_close(ProxyModuleData *data, int open_proxy_found);

/* Close all proxy checks */
void proxy_checks_close(ProxyModuleData *data);

/* proxy checks */
int proxy_scan_r_squid(ProxyCheck *data);
int proxy_scan_w_squid(ProxyCheck *data);

int proxy_scan_r_socks4(ProxyCheck *data);
int proxy_scan_w_socks4(ProxyCheck *data);

int proxy_scan_r_socks5(ProxyCheck *data);
int proxy_scan_w_socks5(ProxyCheck *data);

int proxy_scan_r_wingate(ProxyCheck *data);
int proxy_scan_w_wingate(ProxyCheck *data);
