#ifndef __COMMANDS_H
#define __COMMANDS_H

typedef struct {
        char *name;
        int min_params;
        void (*func)();
} Command;

typedef struct _CommandList CommandList;

void command_register(CommandList *cmdlist, const char *name,
		      int min_params, void (*func)());
void command_unregister(CommandList *cmdlist, const char *name, void (*func)());

Command *command_find(CommandList *cmdlist, const char *name);

/* If argc <= known_args, we can directly use the command line we received.
   if use_last if TRUE, the first known_args-1 + the last arguments are
   returned. If FALSE, the first known_args arguments are returned */
const char *get_current_line(const char *orig_line, int known_args,
			     int use_last, const char *cmd,
			     int argc, const char *args[]);

CommandList *command_list_create(Pool pool);
void command_list_destroy(CommandList *list);

#endif
