/************************************************************************
 *   IRC - Internet Relay Chat, ircd/s_err.c
 *   Copyright (C) 1992 Darren Reed
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define s_RPL_WELCOME		"001 %s :Welcome to the Internet Relay Network %s"
#define s_RPL_YOURHOST		"002 %s :Your host is %s, running version %s"
#define s_RPL_CREATED		"003 %s :This server was created %s"
#define s_RPL_MYINFO		"004 %s %s %s %s %s"
#define s_RPL_BOUNCE		"010 %s %s %d :Please use this Server/Port instead"
#define s_RPL_MAP 		"015 %s :%s"
#define s_RPL_MAPEND 		"017 %s :End of MAP"
#define s_RPL_YOURID		"042 %s :Your universal ID is %s"
#define s_RPL_TRACELINK		"200 %s Link %s%s %s %s V%X%s %d %d %d"
#define s_RPL_TRACECONNECTING	"201 %s Try. %d %s"
#define s_RPL_TRACEHANDSHAKE	"202 %s H.S. %d %s"
#define s_RPL_TRACEUNKNOWN	"203 %s ???? %d %s"
#define s_RPL_TRACEOPERATOR	"204 %s Oper %d %s"
#define s_RPL_TRACEUSER		"205 %s User %d %s"
#define s_RPL_TRACESERVER	"206 %s Serv %d %dS %dC %s %s!%s@%s V%X%s"
#define s_RPL_TRACESERVICE	"207 %s Service %d %s 0x%X 0x%X"
#define s_RPL_TRACENEWTYPE	"208 %s <newtype> 0 %s"
#define s_RPL_TRACECLASS	"209 %s Class %d %d"
#define s_RPL_STATSLINKINFO	NULL
#define s_RPL_STATSCOMMANDS	"212 %s %s %u %u %u"
#define s_RPL_STATSCLINE	"213 %s %c %s %s %s %d %d"
#define s_RPL_STATSNLINE	"214 %s %c %s %s %s %d %d"
#define s_RPL_STATSILINE	"215 %s %c %s %s %s %d %d"
#define s_RPL_STATSKLINE	"216 %s %c %s %s %s %d %d"
#define s_RPL_STATSQLINE	"217 %s %c %s %s %s %d %d"
#define s_RPL_STATSYLINE	"218 %s %c %d %d %d %d %ld %d.%d %d.%d"
#define s_RPL_ENDOFSTATS	"219 %s %c :End of STATS report"
#define s_RPL_UMODEIS		"221 %s %s"
#define s_RPL_SERVICEINFO	NULL
#define s_RPL_ENDOFSERVICES	NULL
#define s_RPL_SERVICE		NULL
#define s_RPL_SERVLIST		"234 %s %s %s %s 0x%X %d :%s"
#define s_RPL_SERVLISTEND	"235 %s %s %d :End of service listing"
#define s_RPL_STATSIAUTH	NULL
#define s_RPL_STATSVLINE	"240 %s %c %s %s %s %d %d"
#define s_RPL_STATSLLINE	"241 %s %c %s %s %s %d %d"
#define s_RPL_STATSUPTIME	"242 %s :Server Up %d days, %d:%02d:%02d"
#define s_RPL_STATSOLINE	"243 %s %c %s %s %s %d %d"
#define s_RPL_STATSHLINE	"244 %s %c %s %s %s %d %d"
#define s_RPL_STATSSLINE	"245 %s %c %s %s %s 0x%X %d"
#define s_RPL_STATSPING		"246 %s %s %d %d %d %d"
#define s_RPL_STATSBLINE	"247 %s %c %s %s %s %d %d"
#define s_RPL_STATSDEFINE	NULL
#define s_RPL_STATSDEBUG	NULL
#define s_RPL_STATSDLINE	"250 %s %c %s %s %s %d %d"
#define s_RPL_LUSERCLIENT	"251 %s :There are %d users and %d services on %d servers"
#define s_RPL_LUSEROP		"252 %s %d :operators online"
#define s_RPL_LUSERUNKNOWN	"253 %s %d :unknown connections"
#define s_RPL_LUSERCHANNELS	"254 %s %d :channels formed"
#define s_RPL_LUSERME		"255 %s :I have %d users, %d services and %d servers"
#define s_RPL_ADMINME		"256 %s :Administrative info about %s"
#define s_RPL_ADMINLOC1		"257 %s :%s"
#define s_RPL_ADMINLOC2		"258 %s :%s"
#define s_RPL_ADMINEMAIL	"259 %s :%s"
#define s_RPL_TRACELOG		"261 %s File %s %d"
#define s_RPL_TRACEEND		"262 %s %s %s.%s :End of TRACE"
#define s_RPL_TRYAGAIN		"263 %s %s :Please wait a while and try again."
#define s_RPL_NONE		NULL
#define s_RPL_AWAY		"301 %s %s :%s"
#define s_RPL_USERHOST		"302 %s :"
#define s_RPL_ISON		"303 %s :"
#define s_RPL_TEXT		NULL
#define s_RPL_UNAWAY		"305 %s :You are no longer marked as being away"
#define s_RPL_NOWAWAY		"306 %s :You have been marked as being away"
#define s_RPL_WHOISUSER		"311 %s %s %s %s * :%s"
#define s_RPL_WHOISSERVER	"312 %s %s %s :%s"
#define s_RPL_WHOISOPERATOR	"313 %s %s :is an IRC Operator"
#define s_RPL_WHOWASUSER	"314 %s %s %s %s * :%s"
#define s_RPL_ENDOFWHO		"315 %s %s :End of WHO list."
#define s_RPL_WHOISCHANOP	NULL
#define s_RPL_WHOISIDLE		"317 %s %s %ld :seconds idle"
#define s_RPL_ENDOFWHOIS	"318 %s %s :End of WHOIS list."
#define s_RPL_WHOISCHANNELS	"319 %s %s :%s"
#define s_RPL_LISTSTART		"321 %s Channel :Users  Name"
#define s_RPL_LIST		"322 %s %s %d :%s"
#define s_RPL_LISTEND		"323 %s :End of LIST"
#define s_RPL_CHANNELMODEIS	"324 %s %s %s %s"
#define s_RPL_UNIQOPIS		"325 %s %s %s"
#define s_RPL_NOTOPIC		"331 %s %s :No topic is set."
#define s_RPL_TOPIC		"332 %s %s :%s"
#define s_RPL_INVITING		"341 %s %s %s"
#define s_RPL_SUMMONING		"342 %s %s :User summoned to irc"
#define s_RPL_INVITELIST	"346 %s %s %s"
#define s_RPL_ENDOFINVITELIST	"347 %s %s :End of Channel Invite List"
#define s_RPL_EXCEPTLIST	"348 %s %s %s"
#define s_RPL_ENDOFEXCEPTLIST	"349 %s %s :End of Channel Exception List"
#define s_RPL_VERSION		"351 %s %s.%s %s :%s"
#define s_RPL_WHOREPLY		"352 %s %s %s %s %s %s %s :%d %s"
#define s_RPL_NAMREPLY		"353 %s %c %s :%s"
#define s_RPL_KILLDONE		NULL
#define s_RPL_CLOSING		"362 %s %s :Closed. Status = %d"
#define s_RPL_CLOSEEND		"363 %s %d: Connections Closed"
#define s_RPL_LINKS		"364 %s %s %s :%d %s"
#define s_RPL_ENDOFLINKS	"365 %s %s :End of LINKS list."
#define s_RPL_ENDOFNAMES	"366 %s %s :End of NAMES list."
#define s_RPL_BANLIST		"367 %s %s %s"
#define s_RPL_ENDOFBANLIST	"368 %s %s :End of Channel Ban List"
#define s_RPL_ENDOFWHOWAS	"369 %s %s :End of WHOWAS"
#define s_RPL_INFO		"371 %s :%s"
#define s_RPL_MOTD		"372 %s :- %s"
#define s_RPL_INFOSTART		"373 %s :Server INFO"
#define s_RPL_ENDOFINFO		"374 %s :End of INFO list."
#define s_RPL_MOTDSTART		"375 %s :- %s Message of the Day - "
#define s_RPL_ENDOFMOTD		"376 %s :End of MOTD command."
#define s_RPL_YOUREOPER		"381 %s :You are now an IRC Operator"
#define s_RPL_REHASHING		"382 %s %s :Rehashing"
#define s_RPL_YOURESERVICE	"383 %s :You are service %s"
#define s_RPL_MYPORTIS		"384 %s %d :Port to local server is\r\n"
#define s_RPL_NOTOPERANYMORE	NULL
#define s_RPL_TIME		"391 %s %s :%s"
#ifdef ENABLE_USERS
#  define s_RPL_USERSSTART	"392 %s :UserID   Terminal  Host"
#  define s_RPL_USERS		"393 %s :%-8s %-9s %-8s"
#  define s_RPL_ENDOFUSERS	"394 %s :End of Users"
#  define s_RPL_NOUSERS		"395 %s :Nobody logged in."
#endif
#define s_ERR_NOSUCHNICK	"401 %s %s :No such nick/channel"
#define s_ERR_NOSUCHSERVER	"402 %s %s :No such server"
#define s_ERR_NOSUCHCHANNEL	"403 %s %s :No such channel"
#define s_ERR_CANNOTSENDTOCHAN	"404 %s %s :Cannot send to channel"
#define s_ERR_TOOMANYCHANNELS	"405 %s %s :You have joined too many channels"
#define s_ERR_WASNOSUCHNICK	"406 %s %s :There was no such nickname"
#define s_ERR_TOOMANYTARGETS	"407 %s %s :%s recipients. %s"
#define s_ERR_NOSUCHSERVICE	"408 %s %s :No such service"
#define s_ERR_NOORIGIN		"409 %s :No origin specified"
#define s_ERR_NORECIPIENT	"411 %s :No recipient given (%s)"
#define s_ERR_NOTEXTTOSEND	"412 %s :No text to send"
#define s_ERR_NOTOPLEVEL	"413 %s %s :No toplevel domain specified"
#define s_ERR_WILDTOPLEVEL	"414 %s %s :Wildcard in toplevel Domain"
#define s_ERR_BADMASK		"415 %s %s :Bad Server/host mask"
#define s_ERR_TOOMANYMATCHES	"416 %s %s %s :Output too long (try locally)"
#define s_ERR_UNKNOWNCOMMAND	"421 %s %s :Unknown command"
#define s_ERR_NOMOTD		"422 %s :MOTD File is missing"
#define s_ERR_NOADMININFO	"423 %s %s :No administrative info available"
#define s_ERR_FILEERROR		"424 %s :File error doing %s on %s"
#define s_ERR_NONICKNAMEGIVEN	"431 %s :No nickname given"
#define s_ERR_ERRONEOUSNICKNAME	"432 %s %s :Erroneous Nickname"
#define s_ERR_NICKNAMEINUSE	"433 %s %s :Nickname is already in use."
#define s_ERR_SERVICENAMEINUSE	NULL
#define s_ERR_SERVICECONFUSED	NULL
#define s_ERR_NICKCOLLISION	"436 %s %s :Nickname collision KILL from %s@%s"
#define s_ERR_UNAVAILRESOURCE	"437 %s %s :Nick/channel is temporarily unavailable"
#define s_ERR_BANNEDNICKCHANGE	"437 %s %s :Can't change nick while banned"
#define s_ERR_USERNOTINCHANNEL	"441 %s %s %s :They aren't on that channel"
#define s_ERR_NOTONCHANNEL	"442 %s %s :You're not on that channel"
#define s_ERR_USERONCHANNEL	"443 %s %s %s :is already on channel"
#define s_ERR_NOLOGIN		"444 %s %s :User not logged in"
#ifndef ENABLE_SUMMON
#  define s_ERR_SUMMONDISABLED	"445 %s :SUMMON has been disabled"
#else
#endif
#ifndef ENABLE_USERS
#  define s_ERR_USERSDISABLED	"446 %s :USERS has been disabled"
#else
#endif
#define s_ERR_NOTREGISTERED	"451 %s :You have not registered"
#define s_ERR_NEEDMOREPARAMS	"461 %s %s :Not enough parameters"
#define s_ERR_ALREADYREGISTRED	"462 %s :Unauthorized command (already registered)"
#define s_ERR_NOPERMFORHOST	"463 %s :Your host isn't among the privileged"
#define s_ERR_PASSWDMISMATCH	"464 %s :Password Incorrect"
#define s_ERR_YOUREBANNEDCREEP	"465 %s :You are banned from this server"
#define s_ERR_YOUWILLBEBANNED	NULL
#define s_ERR_KEYSET		"467 %s %s :Channel key already set"
#define s_ERR_CHANNELISFULL	"471 %s %s :Cannot join channel (+l)"
#define s_ERR_UNKNOWNMODE	"472 %s %c :is unknown mode char to me for %s"
#define s_ERR_INVITEONLYCHAN	"473 %s %s :Cannot join channel (+i)"
#define s_ERR_BANNEDFROMCHAN	"474 %s %s :Cannot join channel (+b)"
#define s_ERR_BADCHANNELKEY	"475 %s %s :Cannot join channel (+k)"
#define s_ERR_BADCHANMASK	"476 %s %s :Bad Channel Mask"
#define s_ERR_NOCHANMODES	"477 %s %s :Channel doesn't support modes"
#define s_ERR_BANLISTFULL	"478 %s %s %s :Channel list is full"
#define s_ERR_NOPRIVILEGES	"481 %s :Permission Denied- You're not an IRC operator"
#define s_ERR_CHANOPRIVSNEEDED	"482 %s %s :You're not channel operator"
#define s_ERR_CANTKILLSERVER	"483 %s %s :You can't kill a server!"
#define s_ERR_RESTRICTED	"484 %s :Your connection is restricted!"
#define s_ERR_UNIQOPRIVSNEEDED	"485 %s :You're not the original channel operator"
#define s_ERR_NOOPERHOST	"491 %s :No O-lines for your host"
#define s_ERR_NOSERVICEHOST	NULL
#define s_ERR_UMODEUNKNOWNFLAG	"501 %s :Unknown MODE flag"
#define s_ERR_USERSDONTMATCH	"502 %s :Can't change mode for other users"
