#ifndef __CHANNEL_MODES_H
#define __CHANNEL_MODES_H

typedef struct _ModeBuffer ModeBuffer;

#define chanmode_get_list(channel, mode) \
	((mode) == 'b' ? &(channel)->bans : \
	 (mode) == 'e' ? &(channel)->banexs : \
	 (mode) == 'I' ? &(channel)->invites : NULL)

/* Channel mode buffer. It's flushed automatically when
   enough modes with arguments are appended. */
ModeBuffer *mode_buffer_create(Channel *channel, SendOptions *sopts,
			       int max_mode_args, int max_line_length);
/* Returns TRUE if anything was sent. */
int mode_buffer_flush(ModeBuffer *buf);

void mode_buffer_append(ModeBuffer *buf, int set, char mode, const char *arg);
void mode_buffer_append_status(ModeBuffer *buf, int set,
			       unsigned int status, Nick *nick);

/* Add to given string the channel modes that don't need arguments.
   Returns the pointer to end of string. */
char *channel_modes_add(char *str, int mode);

/* Parse channel mode changes. Returns TRUE changes were done. */
int channel_modes_parse(Channel *channel, Client *client,
			SendOptions *sopts, SendOptions *reply_sopts,
			int reverse, int noprivileges,
			const char *mode, const char *mode_args[]);

#endif
