#include "common.h"
#include "client-class.h"

static Pool pool;
static ClientClass default_class;

void client_class_init(ClientClass *cclass)
{
	if (cclass->ping_frequency == 0)
                cclass->ping_frequency = client_ping_frequency;

	if (cclass->inbuf_size == 0)
                cclass->inbuf_size = client_inbuf_size;
}

void client_class_deinit(ClientClass *cclass)
{
        p_free(pool, cclass->name);
}

ClientClass *client_get_class(Client *client)
{
        return &default_class;
}

void client_classes_init(void)
{
	pool = pool_create("Client Class", 1024, TRUE);

	memset(&default_class, 0, sizeof(default_class));
        default_class.name = p_strdup(pool, "default");
	client_class_init(&default_class);
}

void client_classes_deinit(void)
{
        client_class_deinit(&default_class);
	pool_unref(pool);
}
