#ifndef __CLIENT_CLASS_H
#define __CLIENT_CLASS_H

typedef struct {
	char *name;

        int ping_frequency;

        /* never 0 - client_class_init() sets to default */
	unsigned int inbuf_size;

        /* 0 = no limit */
	unsigned int max_outbuf_size;
} ClientClass;

/* Initialize client class and make sure the values are sane. */
void client_class_init(ClientClass *cclass);

/* Free memory used by client class. */
void client_class_deinit(ClientClass *cclass);

/* Returns the client class for specified client.
   This should be done only when logging in. */
ClientClass *client_get_class(Client *client);

void client_classes_init(void);
void client_classes_deinit(void);

#endif
