#include "common.h"
#include "irc.h"
#include "iauth-connection.h"

void iauth_parse_command(IAuth *iauth, char *line)
{
        Client *client;
	const char *cmd, *args[COMMAND_MAX_ARGS+1];
        int argc;

	cmd = irc_parse_command(line, &argc, args);
	if (cmd == NULL)
		return;

	switch (*cmd) {
	case IAUTH_REPLY_REJECT:
		break;
	case IAUTH_REPLY_KILL:
		client = hash_lookup(iauth->clients,
				     INT_TO_POINTER(atoi(args[0])));
		if (client != NULL)
			client_kill(client, args[1]);
                break;
	}
}

void iauth_commands_init(void)
{
}

void iauth_commands_deinit(void)
{
}
