#ifndef __SETTINGS_H
#define __SETTINGS_H

extern char *config_file;

/* -- limits -- */

/* servers */
extern int server_max_line_length;
extern int server_max_mode_args;

/* channels */
extern int channel_max_name;
extern int channel_max_topic;
extern int channel_max_key;
extern int channel_max_kickreason;
extern int channel_max_partreason;

/* clients */
extern int client_nick_max_length;
extern int client_user_max_length;
extern int client_realname_max_length;
extern int client_max_away_msg;
extern int client_max_invites;
extern int client_inbuf_size;
extern int client_max_channels;
extern int client_ping_frequency;
extern int client_max_pong_wait;

extern int client_max_mode_args;
extern int client_max_whois_nicks;
extern int client_max_kick_targets;
extern int client_max_msg_targets;
extern int client_max_notice_targets;

extern int client_login_inbuf_size;
extern int client_login_outbuf_size;

/* -- settings -- */
/*#define DEFAULT_CONFIG_FILE_PATH	"/etc/ircd.conf"*/
#define DEFAULT_CONFIG_FILE_PATH	"../../ircd.conf"

#define DEFAULT_CLIENT_CMD_WAIT		2 /* wait for 2 seconds between commands */
#define DEFAULT_CLIENT_CMD_THRESHOLD	5 /* process 5 commands before the wait actually begins */

#define DEFAULT_CLIENT_AWAY_REASON     	"gone"
#define DEFAULT_CLIENT_MODE		"+i"

#define DEFAULT_CHANNEL_TS_MAX_DIFF	(60*5) /* 5min */

extern int client_cmd_wait;
extern int client_cmd_threshold;

extern char *client_default_away_reason;
extern char *client_default_mode;

extern int channel_ts_max_diff;

#define INITIAL_CLIENT_POOL_SIZE \
	(client_inbuf_size + CLIENT_POOL_MIN_SIZE)

IrcNetwork *settings_server_init(void);

void settings_init(void);
void settings_deinit(void);

#endif
