#include "lib.h"
#include "iconfig.h"

ConfigBlock *config_find_block(Config *config, ConfigBlock *block,
			       const char *key)
{
	ConfigItem *item;

	if (block == NULL)
		block = config->root;

	for (item = block->items; item != NULL; item = item->next) {
		if (item->type == CONFIG_ITEM_TYPE_BLOCK &&
		    strcasecmp(key, item->key) == 0)
                        return item->value.block;
	}

        return NULL;
}

ConfigBlock **config_find_blocks(Config *config, ConfigBlock *block,
				 const char *key)
{
        ConfigBlock **blocks;
	ConfigItem *item;
        int alloc_size, size;

	if (block == NULL)
		block = config->root;

        size = 0;
	alloc_size = 10;
	blocks = t_buffer_get_type(ConfigBlock *, alloc_size);

	for (item = block->items; item != NULL; item = item->next) {
		if (item->type == CONFIG_ITEM_TYPE_BLOCK &&
		    strcasecmp(key, item->key) == 0) {
			if (size+1 >= alloc_size) {
				alloc_size *= 2;
				blocks = t_buffer_reget_type(blocks,
							     ConfigBlock *,
							     alloc_size);
			}

                        blocks[size++] = item->value.block;
		}
	}

        blocks[size] = NULL;
        t_buffer_alloc_type(ConfigBlock *, size+1);
        return blocks;
}

ConfigList *config_find_value(ConfigBlock *block, const char *key)
{
	ConfigItem *item;

	for (item = block->items; item != NULL; item = item->next) {
		if (item->type == CONFIG_ITEM_TYPE_VALUE &&
		    strcasecmp(key, item->key) == 0)
                        return item->value.list;
	}

        return NULL;
}

char *config_find_value_first(ConfigBlock *block, const char *key)
{
	ConfigList *list;

	list = config_find_value(block, key);
	return list == NULL ? NULL : list->data;
}
