%{
#include "lib.h"
#include "internal.h"

static ConfigParser *parser;

%}

%option noyywrap
%option nounput

%%

"#"[^\n]*	config_parse_token(parser, TOKEN_TYPE_COMMENT, yytext);

\n		config_parse_token(parser, TOKEN_TYPE_NEWLINE, NULL);

[ \t]+		/* eat up whitespace */

[,{}=;]		config_parse_token(parser, TOKEN_TYPE_PUNCT, yytext);

\"[^\"\n]*[\"\n] config_parse_token(parser, TOKEN_TYPE_STRING, yytext);

[^;, \t\n]+    	config_parse_token(parser, TOKEN_TYPE_STRING, yytext);

%%

int config_lex_parse(ConfigParser *p, const char *fname)
{
	parser = p;

	yyin = fopen(fname, "r");
	if (yyin == NULL)
		return 0;

	yylex();
	fclose(yyin);
	return 1;
}

