#ifndef __CLIENT_COMMANDS_H
#define __CLIENT_COMMANDS_H

#include "commands.h"

#define CLIENT_COMMAND_EXT(cmdname) \
	void cmdname(Client *client, const char *cmd, \
		     int argc, const char *args[])

#define CLIENT_COMMAND(cmdname) \
        CLIENT_COMMAND_EXT(cmdname)

typedef void (*ClientCommandFunc) (Client *c, const char *cmd,
				   int argc, const char *args[]);

void client_command_register(const char *name, int min_params,
			     ClientCommandFunc func);
void client_command_unregister(const char *name, ClientCommandFunc func);

void client_command_parse(Client *client, const char *name,
			  int argc, const char *args[]);

void client_commands_init(void);
void client_commands_deinit(void);

#endif
