#ifndef __IAUTH_CONNECTION_H
#define __IAUTH_CONNECTION_H

#include "../iauth/iauth.h"

struct _IAuth {
        IAuth *next;

	IrcNetwork *network;
	char *modules; /* module,module,.. */

	pid_t pid; /* -1 = not running */
	int cmdin, cmdout, err, data;
	IO io_cmdin, io_err, io_data;

	TBuffer *cmdinbuf, *cmdoutbuf, *errbuf, *databuf;

	IAuthClientInfo clientinfo;
        int client_handle;
	unsigned int data_left;

        HashTable *clients;
};

IAuth *iauth_create(IrcNetwork *network, const char *modules);
void iauth_destroy(IAuth *iauth);

void iauth_send(IAuth *iauth, const char *data);

void iauth_connect_server(const char *address, int port);

void iauth_init(void);
void iauth_deinit(void);

#endif
