#include "common.h"

IrcNetwork *irc_network_create(const char *name, const char *address,
			       const char *channel,
			       IPADDR *ip, int port,
			       IPADDR *my_ip, int my_port)
{
	IrcNetwork *rec;

	rec = i_new(IrcNetwork, 1);
	rec->name = i_strdup(name);
	rec->address = i_strdup(address);
	rec->channel = i_strdup(channel);

	memcpy(&rec->ip, ip, sizeof(IPADDR));
	rec->port = port;

	if (my_ip != NULL)
		memcpy(&rec->my_ip, my_ip, sizeof(IPADDR));
	rec->my_port = my_port;
	return rec;
}

void irc_network_destroy(IrcNetwork *network)
{
	i_free(network->name);
	i_free(network->address);
	i_free(network->channel);
	i_free(network);
}
